   .586
.mmx
.xmm

.model flat,stdcall
option casemap:none


literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm
literal_double		macro	lit_double:vararg
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm
			
literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM
			
CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

CDBL			macro	lit_double:vararg
			exitm	<literal_double(lit_double)>
			endm
    include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include gdiplus.inc
   include opengl32.inc
   include OpenGLUT.inc
   include glu.inc
  
   Include masm32.inc
   include macros.inc
   include graphics.inc
     include music.inc
  	include fFile.inc
  	 include additional.inc
   include hNullString.inc
   include msvcrt.inc
   include quaternions.inc
   include camera.asm
   include mocap.inc
   include tga.inc
   include TriLoader.inc
   include 3D.inc

  
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib opengl32.lib
	includelib glu32.lib
	includelib Graphics.lib
	includelib msvcrt.lib
	includelib Quaternions.lib
	
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
Draw proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

FPS_Count proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
     m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

.data
   ClassName db "GEF",0
   AppName  db "GEF-Game Engine",0
   
   Light_Position		real4	-0.0, 3.0, 3.5, 0.0
	Light_Diffuse		real4	1.0, 1.0, 1.0, 1.0
	Light_Ambient		real4	0.5, 0.5, 0.7, 1.0
	rot_o	real4 0.0
	
	posX real4 0.0
	posY real4 0.0
	posZ real4 0.0
	
	rotX real4 0.0
	rotY real4 0.0
	rotZ real4 0.0
	
	cam_pos VERTEX 	<0.0, 0.0, 0.0>
	cam_ang VERTEX 	<0.0, 0.0, 0.0>
	
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	mclick dword ?
	mclickup dword ?
	
	MOUSE POINT <?>
	dllhnd dword 0
	fb fBVH <0>
	
	hDC dword 0
	hRC dword 0
	o1 fTri <0>
	o2 fTri <0>
	ft TGA <0>
	
	fps_cnt dword 0
	FPS dword 0
	base dword 0
	
	y_sign dword 0
	x_sign dword 0
	
	m_sign dword 0
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp


WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL pic_pntr:dword
	LOCAL q:qword
	LOCAL r:RECT
	LOCAL p:POINT
	LOCAL px:dword, py:dword
	
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED32.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif

		invoke fCenterWindows,hWnd,600,480
		; Do not remove this
		
		invoke fBVHReadData,CADD("Untitled.bvh"),addr fb
		
		
		invoke fEnableOpenGL,hWnd,addr hDC,addr hRC
		invoke fReadTriFile,CADD("room.tri"),addr o1
		invoke fReadTriFile,CADD("map.tri"),addr o2
		
		
		invoke InitKeyboard
	;	fld [eax].fTriData.PositionZ
	;	fstp q
	;	invoke FloatToStr2,q,addr buff
	;	invoke MessageBox,0,addr buff,0,0
		invoke InitKeyboard
		
	;	invoke glEnable,GL_LIGHTING
		invoke glGenLists,96
		mov base,eax
		invoke wglUseFontBitmaps,hDC,32,96,base
		;invoke glEnable,GL_LINE_SMOOTH
		invoke glEnable,GL_DEPTH_TEST
		invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
		invoke gluPerspective,CDBL(45.0),CDBL(1.0),CDBL(1.0),CDBL(200.0)
	;	invoke fSetCamera,CFLT(0.0),CFLT(0.0),CFLT(0.0)
	
		invoke SetTimer,hWnd,1,25,addr Draw
		invoke SetTimer,0,1,1000,addr FPS_Count
		
	.elseif uMsg==WM_SIZE
	;	invoke GetWindowRect,hWnd,addr r
	;	invoke glViewport,0,0,r.right,r.bottom
		
	.elseif uMsg==WM_MOUSEMOVE
		mov eax,lParam
		movzx edx,ax
		mov MOUSE.x,edx
		shr eax,16
		movzx edx,ax
		mov MOUSE.y,edx
		
		
	.elseif uMsg==WM_KEYUP
		invoke InputKeyboadFrb,wParam,0
		.if wParam=="X"
			.if m_sign==0
				inc m_sign
			.else
				push 0
				pop m_sign
			.endif
		.endif
	.elseif uMsg==WM_KEYDOWN
		invoke InputKeyboadFrb,wParam,1
	.elseif uMsg==WM_LBUTTONUP
		.if mclick==1
			;mov mclickup,0
		.endif
		mov mclick,0
		
	.elseif uMsg==WM_LBUTTONDOWN
		mov mclick,1
		mov mclickup,1
		
	;	invoke ReleaseCapture
	;	invoke SendMessage,hWnd,0A1h,2,0  ;  To make the window follow our mouse
	
	.elseif uMsg==MM_MCINOTIFY
		
	.elseif uMsg==WM_USER
			
			
	.elseif uMsg==WM_COMMAND
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	
	xor eax,eax
	ret
WndProc endp

MouseHandler proc uses esi edi hWnd:dword
	LOCAL r:RECT
	LOCAL px,py:dword
	LOCAL p:POINT
	LOCAL buff[256]:dword
		
		invoke memfill,addr cam_pos,12,0
		invoke memfill,addr cam_ang,12,0
		
		invoke GetWindowRect,hWnd,addr r
		;invoke ClipCursor,addr r
		invoke GetCursorPos,addr p
		mov ecx,r.right
		sub ecx,r.left
		shr ecx,1
		add ecx,r.left
		mov px,ecx
		
		mov ecx,r.bottom
		sub ecx,r.top
		shr ecx,1
		add ecx,r.top
		mov py,ecx
		
		mov edx,px
		cmp p.x,edx
		jl no_need
		je next_s
			fld cam_ang.x
			fsub CFLT(2.0)
			fstp cam_ang.x
			jmp next_s
		no_need:
			fld cam_ang.x
			fadd CFLT(2.0)
			fstp cam_ang.x
		next_s:
		
		;jmp next2
		mov ecx,py
		cmp p.y,ecx
		jl @f
		je next2
			fld cam_ang.y
			fsub  CFLT(2.0)
			fstp cam_ang.y
		;	invoke fRotateGlobal,rotX,CFLT(1.0),CFLT(0.0),CFLT(0.0)
			jmp next2
		@@:
			fld cam_ang.y
			fadd  CFLT(2.0)
			fstp cam_ang.y
		;	invoke fRotateGlobal,rotX,CFLT(1.0),CFLT(0.0),CFLT(0.0)
		next2:
		
		
		
		
		mov ecx,px
		.if p.x!=ecx
			invoke SetCursorPos,px,py
		.endif
		mov ecx,py
		.if p.y!=ecx
			invoke SetCursorPos,px,py
		.endif
		;invoke SetCursorPos,px,py
		done:
	
	ret
MouseHandler endp

Draw proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL buff[256]:dword
	LOCAL q:qword
	LOCAL dfx,dfy,dfz:dword
	
	invoke glClearColor,CFLT(0.0),CFLT(0.0),CFLT(0.0),CFLT(0.0)
	invoke glClear,GL_COLOR_BUFFER_BIT
	invoke glClear,GL_DEPTH_BUFFER_BIT
	
	invoke glMatrixMode,GL_MODELVIEW
	invoke glLoadIdentity
;	invoke fSetView
	
;	invoke glLightfv,GL_LIGHT0,GL_DIFFUSE,addr Light_Diffuse
;	invoke glLightfv,GL_LIGHT0,GL_AMBIENT,addr Light_Ambient
;	invoke glLightfv,GL_LIGHT0,GL_POSITION,addr Light_Position
;	invoke glEnable,GL_LIGHT0
	invoke MouseHandler,hWnd
	
	; -------------------------------------- IN HERE--------------------------
	;----------------------------------------IN HERE--------------------------
	;----------------------------------------IN HERE--------------------------
	invoke IsPressed,"W"
	.if eax==1
		;	fld posZ
		;	push CFLT(0.1)
		;		fadd dword ptr[esp]
		;	pop eax
		;	fstp posZ
		; X-Y -Zr (sin cos)
		; Y-Z -Xr (sin cos)
		; X-Z -Yr (sin cos)
		
		; X-Y -Zr (sin cos)
		; Y -Xr   (sin )
		; X-Z -Yr (sin cos)
		
		fld cam_pos.z
		fadd CFLT(0.1)
		fstp cam_pos.z
		invoke Camera_Move,addr cam_pos
	.endif
	
	invoke IsPressed,"S"
	.if eax==1
		;	fld posZ
		;	push CFLT(0.1)
		;		fsub dword ptr[esp]
		;	pop eax
		;	fstp posZ
		fld cam_pos.z
		fsub CFLT(0.1)
		fstp cam_pos.z
;		fldpi 
;		fmul rotY
;		fdiv CFLT(180.0)
;		fsin
;		fmul CFLT(0.1)
;		fadd posX
;		fstp posX
;		
;		fldpi
;		fmul rotY
;		fdiv CFLT(180.0)
;		fcos
;		fmul CFLT(0.1)
;		fchs
;		fadd posZ
;		fstp posZ
;		
;		fldpi
;		fdiv CFLT(180.0)
;		fmul rotX
;		fsin
;		fmul CFLT(0.1)
;		fadd posY
;		fstp posY
		invoke Camera_Move,addr cam_pos
	.endif
	
	invoke IsPressed,"A"
	.if eax==1
	;	fld posX
	;	push CFLT(0.1)
	;		fsub dword ptr[esp]
	;	pop eax
	;	fstp posX
	fld cam_ang.z
	push CFLT(1.0)
		fsub dword ptr[esp]
	pop eax
	fstp cam_ang.z
	.endif
	
	invoke IsPressed,"D"
	.if eax==1
	;	fld posX
	;	push CFLT(0.1)
	;		fadd dword ptr[esp]
	;	pop eax
	;	fstp posX
	
	fld cam_ang.z
	push CFLT(1.0)
		fadd dword ptr[esp]
	pop eax
	fstp cam_ang.z
	.endif
	invoke Camera_Rotate,addr cam_ang
	
	
	@@:
	
	invoke gluPerspective,CDBL(45.0),CDBL(1.0),CDBL(1.0),CDBL(200.0)
;	invoke glRotatef,rotX,CFLT(1.0),CFLT(0.0),CFLT(0.0)
;	invoke glRotatef,rotY,CFLT(0.0),CFLT(1.0),CFLT(0.0)
;	invoke glRotatef,rotZ,CFLT(0.0),CFLT(0.0),CFLT(1.0)
	
;	invoke glTranslatef,posX,posY,posZ
;	invoke glRotatef,m_HeadingDegrees, CFLT(0.0f), CFLT(1.0f), CFLT(0.0f)
;	invoke glRotatef,m_PitchDegrees, CFLT(1.0f), CFLT(0.0f), CFLT(0.0f)
;	invoke glPushMatrix
;	invoke fSetPerspective
;	invoke glPopMatrix
	
;	invoke glTranslatef,ex_posX,ex_posY,ex_posZ
;	invoke fProtoMove,hWnd,0,0,0,0,0
	
	invoke Camera_LookAt
	
	invoke glPushMatrix
	invoke glTranslatef,CFLT(0.0),CFLT(0.0),CFLT(-4.0)
	.if m_sign==0
		invoke fDrawTri,addr o1,GL_TRIANGLES
	.elseif m_sign==1
		invoke fDrawTri,addr o2,GL_TRIANGLES
	.endif
	invoke glPopMatrix
	
	fld rot_o
	fadd CFLT(1.0)
	fstp rot_o
	
	invoke glPushMatrix
	invoke glTranslatef,CFLT(3.0),CFLT(0.0),CFLT(-5.0)
	invoke glScalef,CFLT(0.1),CFLT(0.1),CFLT(0.1)
	invoke glRotatef,CFLT(90.0),CFLT(1.0),CFLT(0.0),CFLT(0.0)
	invoke fBVHDrawLine,addr fb,0
	invoke glPopMatrix
	
	invoke dw2a,FPS,addr buff
	invoke lstrcat,addr buff,CADD(" FPS")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.70)
	
	fld rotX
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" RotX")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.65)
	
	fld rotY
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" RotY")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.60)
	
	fld rotZ
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" RotZ")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.55)
	
	fld _Camera_Position.x
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" PosX")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.50)

	fld _Camera_Position.y
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" PosY")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.45)
	
	fld _Camera_Position.z
	fstp q
	invoke FloatToStr,q,addr buff
	
	invoke lstrcat,addr buff,CADD(" PosZ")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.40)

	
	invoke SwapBuffers,hDC
	inc fps_cnt
	
	ret
Draw endp

FPS_Count proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	push fps_cnt
	pop FPS
	xor ecx,ecx
	mov fps_cnt,ecx
	
	ret
FPS_Count endp

end start